<?php
	// Crowd login page
	// version 0.5

	//////////
	// Configure the following parameters
	//////////
	
	// ScreenSteps Live configuration
	$screenstepslive_domain = 'YOUR-SUBDOMAIN.screenstepslive.com'; // i.e. bmls.screenstepslive.com
	$sslive_token = ''; // 'Remote authentication token' is available from Account > Account Settings screen in ScreenSteps Live
	
	// Crowd configuration
	$crowd_app_name = 'screensteps-live'; // i.e. screensteps-live
	$crowd_app_credential = '';
	$crowd_service_url = ''; // i.e. http://localhost:8095/crowd/services/SecurityServer?wsdl
	
	//////////
	// End Configuration
	//////////
	
	require_once('Crowd.php');
	
	$login_error = '';

	if ( isset($_REQUEST['username']) )
	{
		// User submitted the form. Try to log into Crowd.
		// NOTE: GET or POST is supported as the _REQUEST global is referenced
		$config = array('app_name'       => $crowd_app_name,
					'app_credential' => $crowd_app_credential,
					'service_url'    => $crowd_service_url);
	
		$crowd = new Crowd($config);
		//print_r($crowd);
		
		$app_token = $crowd->authenticateApplication();
		$princ_token = $crowd->authenticatePrincipal($_REQUEST['username'], $_REQUEST['password'], $_SERVER['HTTP_USER_AGENT'], $_SERVER['REMOTE_ADDR']);
		//print ($princ_token);
		
		// Get person info from Crowd
		$person = GetPerson($crowd, $princ_token);
		//print_r($person);
		
		if ($person)
		{
			// Create header for ScreenSteps Live
			$sFirstName= $person['givenName'];
			$sLastName= $person['sn'];
			$sEmail = $person['mail'];
			$sExternalID = ""; 
			$sOrganization = ""; 
			$sToken = $sslive_token;
			$sReturnToURL = urlencode($_REQUEST['sslive_redirect_url']);
			$sTimestamp = (isset($_POST['sslive_redirect_timestamp']) && !empty($_POST['sslive_redirect_timestamp'])) ? $_POST['sslive_redirect_timestamp'] : time(); 
			$sMessage = $sFirstName.$sLastName.$sEmail.$sExternalID.$sOrganization.$sToken.$sTimestamp; 
			$sHash = MD5($sMessage);
			
			// Redirect to ScreenSteps Live
			$sso_url = 'http://'. $screenstepslive_domain . '/login/remote/?'.
				'first_name='.urlencode($sFirstName).'&last_name='.urlencode($sLastName).
				'&email='.urlencode($sEmail).'&external_id='.$sExternalID.'&organization='.$sOrganization.
				'&timestamp='.$sTimestamp."&hash=".$sHash.'&return_to_url='.$sReturnToURL;
			header("Location: " . $sso_url);
			exit();
		} else {
			$login_error = 'Unable to find person in Crowd';
		}
	}
	
	
	// Print off sign-in form
print <<<EOD
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
   "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">

<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">
<head>
  	<meta http-equiv="content-type" content="text/html;charset=UTF-8" />
</head>

<body>
EOD;

if (!empty($login_error)) {
print <<<EOD
	<div>$login_error</div>
EOD;
}

print <<<EOD
	<form action="{$_SERVER['SCRIPT_NAME']}" method="post">
		<div class="field_row">
			<label>Username:</label>
			<input id="username" name="username" type="text" />
		</div>
		<div class="field_row">
			<label>Password:</label>
			<input id="password" name="password" type="password" />
		</div>
		<input type="hidden" name="sslive_redirect_timestamp" value="{$_GET['timestamp']}" />
		<input type="hidden" name="sslive_redirect_url" value="{$_GET['return_to_url']}" />
		<div class="field_row">
			<button id="submit_login" type="submit">Login</button>	
		</div>
	</form>
</body>
</html>
EOD;


// Function for retrieving user info from Crowd
function GetPerson(&$crowd, $principal_token)
{
	$person == NULL;
	
	$response = $crowd->findPrincipalByToken($principal_token);
	if ($response)
	{
		//print_r($response);
		
		// Convert response into person.
		for ($i=0; $i < count($response->attributes->SOAPAttribute); $i++) {
			$person[ $response->attributes->SOAPAttribute[$i]->name ] = $response->attributes->SOAPAttribute[$i]->values->string;
		}
	}

	return $person;
}

?>